
static	char	SccsId[] = {"@(#)dropword.c	1.1	12/17/82"};
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <curses.h>
#include <time.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <signal.h>
#include <fcntl.h>
#ifdef SCANSWITCH
#include <swtab.h>
#endif
#include "score.h"

int	swembarrass, swinstruct, swlevel, swscore, swtime;

char	*pstime, *pslevel;

/*  taken out by alan because we don't have swtab */
#ifdef SCANSWITCH
struct	sw	swtab[] = {
	"-e",	&swembarrass,	NULL,		"Toggle embarrashed option.",
	"-i",	&swinstruct,	NULL,		"Print instructions.",
	"-l",	&swlevel,	&pslevel,	"Set level of play [1-9].",
	"-s",	&swscore,	NULL,		"Print scores.",
	"-t",	&swtime,	&pstime,	"Set time limit.",
	"",	NULL,		NULL,		NULL,
};
#endif

SCORE	newscore;

int	cletters, cwords, ctyped, cerrors, crash;

int	spw		= 3;
int	realtime	= 1;
int	timelimit	= 180; 
int	breakflag;
int	rlock; 

char	newword[256];
char	typoline[256];
char	*baseline;

Brk()		{ signal(SIGINT, Brk); breakflag++; }
Done()		{ alarm(0); Cleanscreen(); Recordscore(newscore); sleep(3);
		  fflush(stdin); echo(); nocrmode(); }

Refresh()	{ if (!rlock++) refresh(); rlock--; }
Initscreen()	{ initscr(); noecho(); crmode(); }
Cleanscreen()	{ clear(); refresh(); endwin(); }

main (argc, argv)
char *argv[];
{
        char s;

	signal(SIGINT, Brk);
	strcpy(newscore.name, (char *) getlogin());
#ifdef SCANSWITCH
	argv = (char **) scanswitch( argc, argv, swtab, 0, 0, NULL);
#else
        while (--argc > 0 && (*++argv)[0] == '-') {
           s = (*argv)[1];
           switch (s) {
	   case 'e':
	   	swembarrass = 1;
		break;
	   case 'i':
	        swinstruct = 1;		
	        break;
	   case 'l':
	        swlevel = 1;
		pslevel = *++argv;	
		break;
	   case 's':
	        swscore = 1;
		break;
	   case 't':
	        swtime = 1;
		pstime = *++argv;
		break;
	   default:
	        fprintf(stderr,"Unknown option: %c\n",s);
		exit(1);			
           }
        }
#endif
	if (swtime	) { timelimit = atoi(pstime); }
	if (swlevel	) { spw = atoi(pslevel); if (spw < 1) spw = 1; }
	if (swembarrass	) { Toggle_embarrass(); exit(0); }
	if (swscore	) { Pxscores(); exit(0); }
	if (swinstruct	) { system("man dropword"); exit(0); }
	
	Initscreen();
	Initbase();
	Initword();

	Dropword();
	Dropword();
	Dropword();
	AsyncClock();
	while (1) Seekanddestroy();
}

AsyncClock()
{
	static	int starttime;
	static	int timeticks;

	if (!starttime) starttime = time(NULL);
	else realtime = time(NULL)-starttime;

	if (timelimit < realtime || breakflag) { Update(); Done(); exit(0); }
	if (timeticks++ % spw == 0) Dropword();
	Update();

	signal(SIGALRM, AsyncClock); alarm(1);
}

Initbase()
{
	register i;

	baseline = (char *) calloc(COLS, sizeof(*baseline));
	for (i=0; i<COLS; i++) baseline[i] = LINES-3;
}

Dropword()
{
	register i;

	move(LINES-2,0);
	deleteln();
	move(0,0);
	insertln();

	for (i=0; i<COLS; i++) {
		move (baseline[i]+1,i);
		addch('-');

		move (baseline[i], i);
		if (isalpha(inch()) && baseline[i])
			{ addch('-'); baseline[i]--; crash++; }
	}

	cletters += Getword(newword); cwords++;
	move(0, (rand() % (COLS-strlen(newword)-2))+1);
	addstr(newword);
}

char *Formattime(time)
{
	static char atime[6];

	sprintf(atime,"%2d:%2d", time/60, time%60);
	if (atime[3] == ' ') atime[3] = '0';
	return(atime);
}

Update()
{
	newscore.time	= realtime;

	newscore.cpm	= crash*12/realtime;
	newscore.wpm	= ctyped*12/realtime;
	newscore.epm	= cerrors*60/realtime;
	newscore.avg	= newscore.wpm - 2*newscore.epm - 3*newscore.cpm;
	
	move(LINES-1, 0);
	printw("[%5s][%d] %8s: %2d wpm, %2d epm, %2d cpm, %2d avg.",
		Formattime(realtime), spw, newscore.name,
		newscore.wpm, newscore.epm, newscore.cpm, newscore.avg);

	if (typoline[0]) printw("  Typo: %s", typoline);
	addch('\n');
	Refresh();
}

Seekanddestroy()
{
	int	i, len;
	char	*pc, *match();
	char	line[256];

	/*	1. Get the word,
	 *	2. Search for it.  If found, destroy, else
	 *	3. too bad.
	 */

	do Getinput(line); while ((len = strlen(line)) == 0);

	for (i=0; i<LINES-1; i++) {
		if ((pc = match(len, line, COLS, stdscr->_y[i]))) {
			if (isalpha(pc[-1]) || isalpha(pc[len])) continue;
			ctyped += len;
			while (len--) *pc++ = ' ';
			typoline[0] = '\0';
			touchwin(stdscr);
			Update();
			return;
		}
	}

	cerrors++;
	putc('\'', stderr);
	strcpy(typoline, line);
	Update();
}

Getinput(psword)
char	*psword;
{
	/*	Read a word from the keyboard.  Be very careful to
	 *	re-read in the event of an interrupt from the alarm.
	 */

	char *psstart = psword;

	while (1) {
		while (read(0, psword, 1) != 1);

		switch (*psword) {
		case '\n':
		case ' ' : *psword = '\0'; return;
		case '-' : if (spw<9) spw++; break;
		case '+' : if (spw>1) spw--; break;
		case '\b': if (psstart < psword) psword--; break;
		case '\177': if (psstart < psword) psword--; break;
		case '\027': psword = psstart; break;
		case '': rlock++; wrefresh(curscr); rlock--; break;
		default  : psword++; break;
		}
	}
}


static	int	pfile, cfile;

Initword()
{
	struct	stat statbuf;

	/*	1. Open the wordlist file (pfile).
	 *	2. Save the filesize on (cfile).
	 *	3. Initialize the random number generator.
	 */

	pfile = open("/usr/dict/words", 0);
	stat("/usr/dict/words", &statbuf);
	cfile = statbuf.st_size;
	srand(getpid());
}

Getword(pword)
char *pword;
{
	register char	*pch;
	register int	len;

 	/*	1. Take a random shot into the wordlist.
	 *	2. Skip to the beginning of the next whole word.
	 *	3. Read it into *pword.
	 *	4. Accept it so long as:
	 *		a) it is only lower case letters, and
	 *		b) word length is between 3 and 12 chars, and
	 *		c) adheres to Robs average weighted word length
	 *		   of 6.2 characters.
	 *	5. Return length.
	 */

	while (1) {
		pch = pword;
		lseek(pfile, rand() % cfile, 0);
		while (read(pfile, pch, 1) == 1 && *pch != '\n');

		for (len=0; read(pfile, pch, 1) == 1; len++, pch++) {
			if (*pch == '\n') {*pch = '\0'; break; }
			if (isupper(*pch) || !isalpha(*pch)) { len = 0; break; }
		}
		
		if (len < 3 || len > 12) continue;
		if (len > 6 && rand()%3) continue;
		return (len);
	}
}
