/*
 * match.c
 *
 * matching function for dropword
 *	simulates match.s,
 * 		Vax assembler code version that used MATHC instruction
 *
 * Jeffrey Mogul	DECWRL		6 January 1986
 */

/*
 * If pattern is a substring of string, returns address of first byte
 * of first matching substring; otherwise, returns null.
 *
 * This uses a stupid algorithm, but the overhead of something fancy
 * probably isn't worth the effort.
 */

char *
match(patternlen, pattern, stringlen, string)
int patternlen;
char *pattern;
int stringlen;
char *string;
{
	register char *startp;
	register char *patp;
	register char *strp;
	register char *laststartp;
	register char *patendp;
	
	startp = string;
	laststartp = &(string[stringlen-patternlen]);
	patendp = &(pattern[patternlen]);
	
	while (startp <= laststartp) {
	    strp = startp;
	    patp = pattern;
	    do {
		if (*patp++ != *strp++)
		    goto nomatch;
	    } while (patp < patendp);
	    return(startp);
nomatch:
	    startp++;
	}
	return(0);
}
