static char SccsId[] = {"@(#)score.c	1.1	12/17/82"};

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <curses.h>
#include "score.h"

#define SCOREFILE	"/usr/games/lib/dropscores"

static	SCORE	ascores[256];
static	SCORE	newscore;
static	short	cscores;
static	char	*pslegend;

Pxscores()
{
	Pxheader();
	Pxscorel();
}

Pxscorel()
{
	int	i, Comparescore();

	Getscores();
	qsort(ascores, cscores, SCORESIZE, Comparescore);
	for (i=0; i<cscores; i++) Pxscore(ascores[i], "");
}

Recordscore(score)
SCORE score;
{
	int i;

	i = Findindexfromname(score.name);

	if (Criteria(&score, i<cscores? &ascores[i] : NULL) == 1)
		Changescore(i, score);

	Pxheader();
	Pxscore(score, pslegend);
	Pxscorel();
}

Changescore(index, score)
SCORE score;
{
	int	fd;
	
	fd = open(SCOREFILE,2);
	lseek(fd, index*SCORESIZE, 0);
	write(fd, &score, SCORESIZE);
	close(fd);
}

Getscores()
{
	int	fd;

	cscores = 0;
	fd = open(SCOREFILE,2);
	while (read(fd, &ascores[cscores], SCORESIZE) == SCORESIZE) cscores++;
	close(fd);
}

Findindexfromname(psname)
char *psname;
{
	register i;

	Getscores();
	for (i=0; i<cscores; i++)
		if (strcmp(ascores[i].name, psname) == 0) break;
	return (i);
}

Pxheader()
{
	printf("NAME	TIME	WPM	EPM	CPM	AVG\n");
}

Pxscore(score, pslegend)
SCORE	score;
char	*pslegend;
{
	if (score.embarrassed && !*pslegend && getuid() != 254) return;

	printf("%s\t%s\t%2d\t%2d\t%2d\t%2d %s\n",
		score.name, (char *) Formattime(score.time),
		score.wpm, score.epm, score.cpm, score.avg, pslegend);
}

Comparescore(a, b)
SCORE *a, *b;
{
	if (a->avg < b->avg) return ( 1);
	if (a->avg > b->avg) return (-1);
	return (0);
}

Criteria(new, old)
SCORE *new, *old;
{
	if (new->time < 180) {
		pslegend = " <--- Game score [ < 3 min. limit  ]\n";
		return (0);
	} else
	if (old == NULL) {
		pslegend = " <--- Game score [ First game score]\n";
		return (1);
	} else
	if (old->avg == new->avg) {
		pslegend = " <--- Game score [ Same as record  ]\n";
		return (1);
	} else
	if (old->avg < new->avg) {
		pslegend = " <--- Game score [ Congratulations! ]\n";
		return (1);
	} else	{
		pslegend = " <--- Game score [ What happened?  ]\n";
		return (0);
	}
}

Toggle_embarrass()
{
	register i;

	i = Findindexfromname((char *) getlogin());
	if (i < cscores) {
		ascores[i].embarrassed = 1-ascores[i].embarrassed;
		Changescore(i, ascores[i]);

		if (ascores[i].embarrassed)
			printf("Your embarrassment is now private!\n");
		else
			printf("Your accomplishment is now public!\n");
	}
}
